<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="发送者ID" prop="senderId">
        <el-input v-model="formData.senderId" placeholder="请输入发送者ID" />
      </el-form-item>
      <el-form-item label="接收者ID" prop="receiverId">
        <el-input v-model="formData.receiverId" placeholder="请输入接收者ID" />
      </el-form-item>
      <el-form-item label="消息内容">
        <Editor v-model="formData.content" height="150px" />
      </el-form-item>
      <el-form-item label="消息类型" prop="type">
        <el-select v-model="formData.type" placeholder="请选择消息类型">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.MESSAGE_TYPE.toUpperCase())"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="翻译内容">
        <Editor v-model="formData.translatedContent" height="150px" />
      </el-form-item>
      <el-form-item label="消息语言" prop="language">
        <el-input v-model="formData.language" placeholder="请输入消息语言" />
      </el-form-item>
      <el-form-item label="翻译语言" prop="translationLanguage">
        <el-input v-model="formData.translationLanguage" placeholder="请输入翻译语言" />
      </el-form-item>
      <el-form-item label="是否已度" prop="isRead">
        <el-radio-group v-model="formData.isRead">
          <el-radio
            v-for="dict in getBoolDictOptions(DICT_TYPE.INFRA_YES_NO.toUpperCase())"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="已撤回" prop="isRetracted">
        <el-radio-group v-model="formData.isRetracted">
          <el-radio
            v-for="dict in getBoolDictOptions(DICT_TYPE.INFRA_YES_NO.toUpperCase())"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { DICT_TYPE, getIntDictOptions, getBoolDictOptions } from '@/utils/dict'
import * as ContentApi from '@/api/message/content'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  senderId: undefined,
  receiverId: undefined,
  content: undefined,
  type: undefined,
  translatedContent: undefined,
  language: undefined,
  translationLanguage: undefined,
  isRead: undefined,
  isRetracted: undefined
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ContentApi.getContent(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as ContentApi.ContentVO
    if (formType.value === 'create') {
      await ContentApi.createContent(data)
      message.success(t('common.createSuccess'))
    } else {
      await ContentApi.updateContent(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    senderId: undefined,
    receiverId: undefined,
    content: undefined,
    type: undefined,
    translatedContent: undefined,
    language: undefined,
    translationLanguage: undefined,
    isRead: undefined,
    isRetracted: undefined
  }
  formRef.value?.resetFields()
}
</script>
